## gcc-msp430 4.5.3~mspgcc-4.5.2

=== docs/Makefile ===
.PHONY: all html pdf manual-html faq-html faq-pdf manual-pdf clean clean-workfiles FORCE


HTMLDIR=../htdocs/html

ifndef MSYSCON
ifdef WINDIR
STYLESHEET := "$(shell cygpath -w `pwd`)/stylesheet.css"
else
STYLESHEET := "$(shell pwd)/stylesheet.css"
endif
else
STYLESHEET := "$(shell pwd)/stylesheet.css"
endif


RST2HTML = python -c "from docutils.core import publish_cmdline; publish_cmdline(writer_name='html')"
HTMLOPT  = --stylesheet=$(STYLESHEET)

%.html: %.txt stylesheet.css
	$(RST2HTML) $(HTMLOPT) $< $@

all: documentation.html
#~ info.html tutorial.html

dookbook-stuff: html pdf
html: manual-html faq-html
pdf:  manual-pdf faq-pdf

manual-html:
	mkdir -p $(HTMLDIR)
	docbook2html -o $(HTMLDIR)/manual mspgcc-manual.xml

faq-html:
	mkdir -p $(HTMLDIR)
	docbook2html -o $(HTMLDIR)/faq faq.xml


faq-pdf:
	docbook2tex --dsl mspgcc.dsl#print faq.xml
	#run tex 3 times so that page numbers match (TeX feature ;-)
	pdfjadetex faq.tex
	pdfjadetex faq.tex >/dev/null
	pdfjadetex faq.tex >/dev/null

manual-pdf:
	docbook2tex --dsl mspgcc.dsl#print mspgcc-manual.xml
	#run tex 3 times so that page numbers match (TeX feature ;-)
	pdfjadetex mspgcc-manual.tex
	pdfjadetex mspgcc-manual.tex >/dev/null
	pdfjadetex mspgcc-manual.tex >/dev/null

clean-workfiles:
	rm -f mspgcc-manual.aux mspgcc-manual.log mspgcc-manual.out mspgcc-manual.tex
	rm -f faq.aux faq.log faq.out faq.tex

htmldir:
	mkdir -p html

faq-eclipse: FORCE htmldir
	xsltproc --stringparam base.dir html/faq/ --stringparam html.stylesheet ../styles.css /usr/share/xml/docbook/stylesheet/nwalsh/eclipse/eclipse.xsl faq.xml
	mv toc.xml toc-faq.xml

manual-eclipse: FORCE htmldir
	xsltproc --stringparam base.dir html/manual/ --stringparam html.stylesheet ../styles.css /usr/share/xml/docbook/stylesheet/nwalsh/eclipse/eclipse.xsl mspgcc-manual.xml
	mv toc.xml toc-manual.xml

clean: clean-workfiles
	rm -f documentation.html
	rm -f mspgcc-manual.pdf faq.pdf
	rm -rf faq manual

FORCE:

=== htdocs/Makefile ===
# Make rules for mspgcc.sf.net ht->html generation.  SOURCES
# indirection filters out "*.ht" value when no ht files are around.
THEUSER = $(shell cat username)

SOURCES =	$(shell echo *.ht)
TARGETS =	$(filter-out *.html,$(SOURCES:%.ht=%.html)) $(EXTRA_TARGETS)
GENERATED_HTML= $(SOURCES:.ht=.html)

HTROOT = 	html
HT2HTML =	ht2html/ht2html.py
HTSTYLE =	mspgccGenerator
HTALLFLAGS =	-f -s $(HTSTYLE)
HTFLAGS =	$(HTALLFLAGS) -r $(HTROOT)

DEST = 		$(THEUSER):/home/groups/m/ms/mspgcc/htdocs
CGIDEST = 	$(THEUSER):/home/groups/m/ms/mspgcc/cgi-bin
EXCLUDES =	--exclude=CVS --exclude=cgi-bin --exclude=ht2html --exclude=manual --exclude=faq --exclude=username --exclude=\*.ht
CGIEXCLUDES =	--exclude=CVS --exclude=not_the_real_cgi_here.txt
RARGS = 	--rsh=ssh -v -r -l -t --update --delete $(EXCLUDES)
XMLRARGS = 	--rsh=ssh -v -r -l -t --update --delete
CGIRARGS = 	--rsh=ssh -v -r -l -t --update --delete $(CGIEXCLUDES)

.SUFFIXES:	.ht .html

.ht.html:
	$(HT2HTML) $(HTFLAGS) $<

all: destdir $(TARGETS)

destdir:
	mkdir -p $(HTROOT)

#dependencies for the ht files
$(TARGETS): links.h

clean:
	-rm -f *~
	-rm $(GENERATED_HTML)

install: docinstall cgiinstall

docinstall: all
	rsync $(RARGS) . $(DEST)

cgiinstall:
	rsync $(CGIRARGS) cgi-bin/ $(CGIDEST)

xmlinstall:
	#~ cd ../docs; make
	rsync $(XMLRARGS) ../docs/faq/ $(DEST)/faq
	rsync $(XMLRARGS) ../docs/manual/ $(DEST)/manual

username:
	echo $(USER)@mspgcc.sf.net >$@

## gcc-msp430 4.5.3~mspgcc-4.5.2-20110612

=== debian/changelog ===
gcc-msp430 (4.5.3~mspgcc-4.5.2-20110612-1) unstable; urgency=low

  * New upstream release
    + First official mspgcc tarball

 -- Luca Bruno <lucab@debian.org>  Mon, 13 Jun 2011 12:17:44 +0200

gcc-msp430 (4.5.3~msp20110421-1) unstable; urgency=low

  * Upload to Debian Unstable

 -- Luca Bruno <lucab@debian.org>  Wed, 01 Jun 2011 15:59:24 +0200

gcc-msp430 (4.5.2~msp20110421-0exp1) experimental; urgency=low

  * Initial upload to Debian (Closes: #137712)

 -- Luca Bruno <lucab@debian.org>  Fri, 22 Apr 2011 16:12:45 +0200

=== debian/control ===
Source: gcc-msp430
Section: devel
Priority: extra
Maintainer: Luca Bruno <lucab@debian.org>
Standards-Version: 3.9.2
Build-Depends: 	autoconf (>= 2.13), bison, flex, gettext, texinfo,
		binutils (>= 2.9.5.0.12), gcc (>= 2.95.2), 
		debhelper (>= 7), tar (>= 1.13.18), bzip2, 
		findutils(>=4.2.31), gcc-4.5-source (>= 4.5.2),
		libgmp-dev (>= 2:5.0.1+dfsg-7), libmpfr-dev,
		libmpc-dev, libzip-dev, binutils-msp430 (>= 2.21~),
		msp430mcu
Build-Conflicts: binutils-multiarch
Built-Using: gcc-4.5 (= 4.5.3-1)

Package: gcc-msp430
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, msp430mcu, binutils-msp430 (>= 2.21~)
Recommends: msp430-libc
Description: The GNU C compiler (cross compiler for MSP430)
 This is the GNU C compiler, a fairly portable optimizing compiler for C
 for TI's MSP430 architecture.  This package is primarily for MSP430 
 developers and cross-compilers and is not needed by normal users.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

PACKAGE=gcc-msp430
TARGET=msp430

CONFARGS = -v \
           --enable-languages=c,c++ \
           --prefix=/usr \
           --infodir=\$${prefix}/share/info \
           --mandir=\$${prefix}/share/man \
           --bindir=\$${prefix}/bin \
           --libexecdir=\$${prefix}/lib \
           --libdir=\$${prefix}/lib \
           --enable-shared \
           --with-system-zlib \
           --enable-long-long \
           --enable-nls \
           --without-included-gettext \
           --disable-checking \
           --disable-libssp \
           --build=$(DEB_BUILD_GNU_TYPE) \
           --host=$(DEB_HOST_GNU_TYPE) \
           --target=$(TARGET)

BUILD_TREE = $(shell find . -maxdepth 1 -mindepth 1 -type d -name 'gcc*')
DEB_SOURCE = /usr/src/gcc-4.5/
BUILD_RES = build-result

unpack: unpack-stamp
unpack-stamp: 
	tar xJf $(DEB_SOURCE)/gcc-*.tar.*
	touch unpack-stamp

patch-stamp: unpack-stamp
	cd $(BUILD_TREE) && \
	for upstreamp in `grep -v '^#' $(CURDIR)/debian/patchlist`; \
		do echo; echo Applying patch $$upstreamp; \
		patch -p1 < $(CURDIR)/debian/$$upstreamp; done
	touch patch-stamp

configure: configure-stamp
configure-stamp: patch-stamp
	dh_testdir
	mkdir -p $(BUILD_RES)
	cd $(BUILD_RES) && $(CURDIR)/$(BUILD_TREE)/configure $(CONFARGS)
	touch configure-stamp

build: build-stamp
build-stamp: configure-stamp
	dh_testdir
	$(MAKE) $(MAKEFLAGS) -C $(BUILD_RES)
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp unpack-stamp patch-stamp
	rm -rf $(BUILD_TREE) 
	rm -rf $(BUILD_RES) 
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	$(MAKE) $(MAKEFLAGS) -C $(BUILD_RES) install prefix=$(CURDIR)/debian/$(PACKAGE)/usr

	# Remove conflicting and empty files
	rm -rf debian/$(PACKAGE)/usr/share/info
	rm -rf debian/$(PACKAGE)/usr/share/man
	rm -rf debian/$(PACKAGE)/usr/msp430/
	rm -rf debian/$(PACKAGE)/usr/lib/libiberty.a

binary-indep: install

binary-arch: install
	dh_testdir
	dh_testroot
	dh_installdocs -n
	dh_installman
	dh_installchangelogs
	dh_link
	# We'd really need cross-stripping here, instead
	dh_strip -Xlibgcc.a -Xlibcrt0.a -Xcrt0ivtbl64.o \
		 -Xlibgcov.a -Xlibcrt0dwdt.a -Xcrt0ivtbl16.o \
		 -Xcrt0ivtbl32.o 
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## gcc-msp430 4.5.3~mspgcc-20110716

=== debian/changelog ===
gcc-msp430 (4.5.3~mspgcc-20110716-4) unstable; urgency=low

  * Fix building targets in debian/rules

 -- Luca Bruno <lucab@debian.org>  Wed, 18 Jan 2012 21:17:05 +0100

gcc-msp430 (4.5.3~mspgcc-20110716-3) unstable; urgency=low

  * Upstream patch-point
    + SF 3433730: Bug when casting function parameters

 -- Luca Bruno <lucab@debian.org>  Sun, 06 Nov 2011 09:25:18 +0100

gcc-msp430 (4.5.3~mspgcc-20110716-2) unstable; urgency=low

  * Upstream patch-point
    + SF 3409864: Args overwritten after call involving int64
    + SF 3417263: GDB wrong address for variables
    + SF 3431602: Incorrect comparison to 32-bit literal

 -- Luca Bruno <lucab@debian.org>  Fri, 04 Nov 2011 22:33:24 +0100

gcc-msp430 (4.5.3~mspgcc-20110716-1) unstable; urgency=low

  * Upstream patch-point
    + SF 3370978: ICE on shift with 32-bit count
    + SF 3390964: broken optimization with emulated multiply libcalls
    + SF 3394176: unrecognizable insn error subtracting addresses
    + SF 3396639: restore lost source listings (and perhaps debugger support)

 -- Luca Bruno <lucab@debian.org>  Tue, 23 Aug 2011 10:36:00 +0200

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,7 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, msp430mcu, binutils-msp430 (>= 2.21~)
 Recommends: msp430-libc
-Description: The GNU C compiler (cross compiler for MSP430)
+Description: GNU C compiler (cross compiler for MSP430)
  This is the GNU C compiler, a fairly portable optimizing compiler for C
  for TI's MSP430 architecture.  This package is primarily for MSP430 
  developers and cross-compilers and is not needed by normal users.

=== debian/rules ===
--- 
+++ 
@@ -5,6 +5,7 @@
 
 PACKAGE=gcc-msp430
 TARGET=msp430
+VERSION = $(shell dpkg-parsechangelog | sed -n 's/^Version:.*\(msp.*\)-.*$$/\1/p')
 
 CONFARGS = -v \
            --enable-languages=c,c++ \
@@ -23,7 +24,8 @@
            --disable-libssp \
            --build=$(DEB_BUILD_GNU_TYPE) \
            --host=$(DEB_HOST_GNU_TYPE) \
-           --target=$(TARGET)
+           --target=$(TARGET) \
+	   --with-pkgversion="GNU GCC patched $(VERSION)"  
 
 BUILD_TREE = $(shell find . -maxdepth 1 -mindepth 1 -type d -name 'gcc*')
 DEB_SOURCE = /usr/src/gcc-4.5/
@@ -48,7 +50,9 @@
 	cd $(BUILD_RES) && $(CURDIR)/$(BUILD_TREE)/configure $(CONFARGS)
 	touch configure-stamp
 
-build: build-stamp
+build: build-arch build-indep
+build-arch: build-stamp
+build-indep: build-stamp
 build-stamp: configure-stamp
 	dh_testdir
 	$(MAKE) $(MAKEFLAGS) -C $(BUILD_RES)

## gcc-msp430 4.6.3~mspgcc-20120406

=== debian/changelog ===
gcc-msp430 (4.6.3~mspgcc-20120406-7ubuntu3) utopic; urgency=medium

  * Drop restoreconfig from d/rules, trying to fix FTBFS.

 -- Artur Rona <ari-tczew@ubuntu.com>  Thu, 28 Aug 2014 00:02:36 +0200

gcc-msp430 (4.6.3~mspgcc-20120406-7ubuntu2) utopic; urgency=medium

  * Switch from autoreconf to autotools, now it should start working.

 -- Artur Rona <ari-tczew@ubuntu.com>  Wed, 27 Aug 2014 08:51:25 +0200

gcc-msp430 (4.6.3~mspgcc-20120406-7ubuntu1) utopic; urgency=medium

  * debian/control, debian/rules:
    - Use dh-autoreconf to get new libtool macros for ppc64el
      and update config.{sub,guess} for new arches. (Closes: #744434)

 -- Artur Rona <ari-tczew@ubuntu.com>  Wed, 27 Aug 2014 00:30:52 +0200

gcc-msp430 (4.6.3~mspgcc-20120406-7) unstable; urgency=medium

  * Fix generation of wrong interrupt table for MSP430FR5xxx 
    targets, resulting in security fuse blown (Closes: #706482) 

 -- Luca Bruno <lucab@debian.org>  Sat, 23 Aug 2014 19:38:20 +0200

gcc-msp430 (4.6.3~mspgcc-20120406-6) unstable; urgency=high

  * Fix ICE by backporting pr54638, now building with standard gcc
    (Closes: #747998) 

 -- Luca Bruno <lucab@debian.org>  Sun, 17 Aug 2014 15:46:15 +0200

gcc-msp430 (4.6.3~mspgcc-20120406-5) unstable; urgency=medium

  * Use gcc-4.7 for building (Closes: #701281)
  * Do not build info doc (Closes: #712342)

 -- Luca Bruno <lucab@debian.org>  Fri, 12 Jul 2013 19:52:56 +0200

gcc-msp430 (4.6.3~mspgcc-20120406-4) unstable; urgency=high

  * Change package description to mention the incompatibility
    with MSP430FR5xxx chips (eg. Fraunchpad board).
    This package DOES NOT work on that chips series, and will
    brick your hardware
  * Do not use embedded zlib for building

 -- Luca Bruno <lucab@debian.org>  Thu, 02 May 2013 13:40:16 +0200

gcc-msp430 (4.6.3~mspgcc-20120406-3) unstable; urgency=low

  * Disable features not relevant to msp430

 -- Luca Bruno <lucab@debian.org>  Sun, 20 May 2012 13:53:14 +0200

gcc-msp430 (4.6.3~mspgcc-20120406-2) unstable; urgency=low

  * Upload to unstable 

 -- Luca Bruno <lucab@debian.org>  Fri, 18 May 2012 20:45:00 +0200

gcc-msp430 (4.6.3~mspgcc-20120406-1) experimental; urgency=low

  * New upstream release   
  * Due to upstream and debian gcc-source de-synchronization,
    vanilla sources are now embedded here along with patches

 -- Luca Bruno <lucab@debian.org>  Thu, 17 May 2012 09:04:24 +0200

=== debian/control ===
Source: gcc-msp430
Section: devel
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Luca Bruno <lucab@debian.org>
Standards-Version: 3.9.5
Build-Depends: 	autoconf (>= 2.13), bison, flex, gettext, texinfo,
		binutils (>= 2.9.5.0.12), gcc (>= 2.95.2), 
		debhelper (>= 7), tar (>= 1.13.18), bzip2, 
		findutils(>=4.2.31), libgmp-dev (>= 2:5.0.1+dfsg-7), 
		libmpfr-dev, libmpc-dev, libzip-dev, 
		binutils-msp430 (>= 2.21~), msp430mcu, autotools-dev
Build-Conflicts: binutils-multiarch

Package: gcc-msp430
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, msp430mcu, binutils-msp430 (>= 2.21~)
Recommends: msp430-libc
Description: GNU C compiler (cross compiler for MSP430)
 This is the GNU C compiler, a fairly portable optimizing compiler for C
 for TI's MSP430 architecture.  This package is primarily for MSP430 
 developers and cross-compilers and is not needed by normal users.
 .
 BEWARE: due to a bug in the memory layout reference of FRAM-based chips, 
 this package DOES NOT WORK with MSP430FR5xxx chips (eg. FraunchPad devkit).
 DO NOT use gcc-msp430 on that chip series, as you will lose access to
 JTAG and BSL, and permanently BRICK your chip!

=== debian/rules ===
--- 
+++ 
@@ -10,30 +10,24 @@
 CONFARGS = -v \
            --enable-languages=c,c++ \
            --prefix=/usr \
+           --with-system-zlib \
            --infodir=\$${prefix}/share/info \
            --mandir=\$${prefix}/share/man \
            --bindir=\$${prefix}/bin \
            --libexecdir=\$${prefix}/lib \
            --libdir=\$${prefix}/lib \
-           --enable-shared \
-           --with-system-zlib \
-           --enable-long-long \
-           --enable-nls \
-           --without-included-gettext \
-           --disable-checking \
-           --disable-libssp \
            --build=$(DEB_BUILD_GNU_TYPE) \
            --host=$(DEB_HOST_GNU_TYPE) \
-           --target=$(TARGET) \
-	   --with-pkgversion="GNU GCC patched $(VERSION)"  
+	   MAKEINFO=missing \
+           --target=$(TARGET)
 
 BUILD_TREE = $(shell find . -maxdepth 1 -mindepth 1 -type d -name 'gcc*')
-DEB_SOURCE = /usr/src/gcc-4.5/
+DEB_SOURCE = ./
 BUILD_RES = build-result
 
 unpack: unpack-stamp
 unpack-stamp: 
-	tar xJf $(DEB_SOURCE)/gcc-*.tar.*
+	tar xaf $(DEB_SOURCE)/gcc-*.tar.*
 	touch unpack-stamp
 
 patch-stamp: unpack-stamp
@@ -46,7 +40,9 @@
 configure: configure-stamp
 configure-stamp: patch-stamp
 	dh_testdir
+	dh_autotools-dev_updateconfig
 	mkdir -p $(BUILD_RES)
+	sed -i 's/BUILD_INFO=info/BUILD_INFO=/' $(BUILD_TREE)/configure
 	cd $(BUILD_RES) && $(CURDIR)/$(BUILD_TREE)/configure $(CONFARGS)
 	touch configure-stamp
